﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Ektron.Cms;
using Ektron.Cms.Common;
using Ektron.Cms.Instrumentation;
using Ektron.Cms.Extensibility;
using Ektron.Cms.Extensibility.Content;


namespace Cms.Extensions.Templates
{
    public class TaxonomyStrategyTemplate : TaxonomyStrategy
    {
        public override void OnBeforeAdd(TaxonomyData taxonomyData, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnBeforeAdd: Name - {0}", taxonomyData.Name));
        }

        public override void OnAfterAdd(TaxonomyData taxonomyData, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnAfterAdd: Name - {0}", taxonomyData.Name));
        }

        public override void OnBeforeUpdate(TaxonomyData taxonomyData, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnBeforeUpdate: Name - {0}", taxonomyData.Name));
        }

        public override void OnAfterUpdate(TaxonomyData taxonomyData, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnAfterUpdate: Name - {0}", taxonomyData.Name));
        }

        public override void OnBeforeDelete(long id, int languageId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnBeforeAdd: Name - {0} - ID {1}", id, languageId));
        }

        public override void OnAfterDelete(long id, int languageId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnAfterDelete: Name - {0} - ID {1}", id, languageId));
        }

        public override void OnBeforeAssignItem(TaxonomyRequest request, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnBeforeAssignItem: Taxonomy Id - {0}, Item Type - {1}, Item Ids - {2}",
                request.TaxonomyId.ToString(),
                request.TaxonomyItemType.ToString(),
                request.TaxonomyIdList));
        }

        public override void OnAfterAssignItem(TaxonomyRequest request, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("TaxonomyStrategyTemplate.OnAfterAssignItem: Taxonomy Id - {0}, Item Type - {1}, Item Ids - {2}",
                 request.TaxonomyId.ToString(),
                 request.TaxonomyItemType.ToString(),
                 request.TaxonomyIdList));
        }


    }
}
