﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Ektron.Cms;
using Ektron.Cms.Common;
using Ektron.Cms.Instrumentation;
using Ektron.Cms.Extensibility;
using System.Diagnostics;

namespace Cms.Extensions.Templates
{
    public class UserStrategyTemplate : UserStrategy 
    {
        public override void OnBeforeAddUser(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeAddUser: User {0}", userData.Username));
        }

        public override void OnAfterAddUser(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterAddUser: User {0}", userData.Username));
        }

        public override void OnBeforeDeleteUser(long id, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeDeleteUser: User {0}", id));
        }

        public override void OnAfterDeleteUser(long id, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterDeleteUser: User {0}", id));
        }

        public override void OnBeforeUpdateUser(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeUpdateUser: User {0}", userData.Username));
        }

        public override void OnAfterUpdateUser(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterUpdateUser: User {0}", userData.Username));
        }

        public override void OnBeforeLogin(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeLogin: User {0}", userData.Username));
        }

        public override void OnAfterLogin(UserData userData, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterLogin: User {0}", userData.Username));
        }

        public override void OnAfterAddColleague(long userOneId, long userTwoId, CmsEventArgs eventArgs) 
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterAddColleague: User One {0}, User Two {1}", userOneId, userTwoId));
        }

        public override void OnBeforeUserAddInGroup(long userId, long groupId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeUserAddInGroup: User {0}, User Group {1}", userId, groupId));
        }

        public override void OnAfterUserAddInGroup(long userId, long groupId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterUserAddInGroup: User {0}, User Group {1}", userId, groupId));
        }

        public override void OnBeforeUserDeleteFromGroup(long userId, long groupId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnBeforeUserDeleteFromGroup: User {0}, User Group {1}", userId, groupId));
        }

        public override void OnAfterUserDeleteFromGroup(long userId, long groupId, CmsEventArgs eventArgs)
        {
            Log.WriteInfo(string.Format("UserStrategyTemplate.OnAfterUserDeleteFromGroup: User {0}, User Group {1}", userId, groupId));
        }

    }
}
